'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

var _cookies = require('./cookies');

var _cookies2 = _interopRequireDefault(_cookies);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _isAPP = false;

var composePostData = function composePostData(param) {
    var postData = { "data": { "phead": phead }, "shandle": 0 };
    var htmlUrl = encodeURI(param + '&data=' + JSON.stringify(postData));
    return htmlUrl;
};

/**
 * TODO 给链接添加参数
 * 
 * @param {any} nameArr 
 * @param {any} url 
 * @returns 
 */
function changeUrl(nameArr, url) {
    for (var i = 0; i < nameArr.length; i++) {
        var sys = '?';
        if (url.indexOf('?') > -1) {
            sys = '&';
        }
        if (!getUrlParam(nameArr[i], url) && $.getUrlParam(nameArr[i])) {
            url += sys + nameArr[i] + '=' + $.getUrlParam(nameArr[i]);
        }
    }
    return url;
}

/**
 * 非app时跳转页面
 * @param {object} param 跳转页面参数
 */
var platformLaunchH5 = function platformLaunchH5(param) {
    if (!param) {
        return;
    }
    if (typeof param === 'string') {
        param = JSON.parse(param);
    }
    if ((typeof param === 'undefined' ? 'undefined' : _typeof(param)) === 'object') {
        var htmlUrl = param.launchParams.htmlUrl;
        //往url添加参数
        htmlUrl = changeUrl(['prd_id', 'channel', 'shownav'], htmlUrl);
        if (param.launchParams.withHead) {
            htmlUrl = composePostData(htmlUrl);
        }
        window.location.href = htmlUrl;
    }
};

/**
 * TODO 非app时跳转登录
 */
var platformGotoLoginH5 = function platformGotoLoginH5() {
    var htmlUrl = location.origin + '/fanli_service/pages/sdk_campaign/login/index.jsp';
    htmlUrl = changeUrl(['prd_id', 'channel', 'shownav'], htmlUrl);
    window.location.href = htmlUrl;
};

/**
 * 非app时初始化phead，
 */
var initPheadForH5 = function initPheadForH5() {
    var tphead = { "pversion": "30", "cversion": 0, "cityid": "440100", "gcityid": "440100" },
        cookie = new _cookies2.default();

    var cookiePhead = cookie.get('phead'),
        prdid = void 0,
        channel = void 0;

    if (cookiePhead) {
        try {
            tphead = JSON.parse(cookiePhead);
            return;
        } catch (e) {
            //
        }
    }

    // 处理平台
    if (_utils2.default.isIOS()) {
        tphead.platform = 'ios';
    } else {
        tphead.platform = 'android';
    }

    prdid = _utils2.default.getQueryParam('prd_id');
    if (prdid) {
        tphead.prdid = prdid;
    }

    channel = _utils2.default.getQueryParam('channel');
    if (prdid) {
        tphead.channel = channel;
    }

    phead = tphead;
};

function getUrlParam(param_name, url) {
    var reg = new RegExp("(^|&)" + param_name + "=([^&]*)(&|$)");
    var urlSearchPot = url.indexOf('?');
    if (urlSearchPot <= -1) {
        return null;
    }
    var r = url.substr(urlSearchPot + 1, url.length).match(reg);
    if (r != null) return unescape(r[2]);
    return null;
};

/**
 * 针对H5页面进行bridge、phead兼容
 */
var bridgePolyfill = function bridgePolyfill(currentPhead) {
    // 根据phead判断是否在app内，车主无忧为空或者1005~1009，财迷之家为4000，微信为1010，H5为4500以上
    // pheadFromHead 这个是jsp中定义的参数，见 common_header.jsp
    if (currentPhead != null && (_utils2.default.isNull(currentPhead.prdid) || currentPhead.prdid < 4500 && currentPhead.prdid != 1010)) {
        // APP内
        _isAPP = true;
        phead = currentPhead;
    } else {
        //重写platform_launch方法兼容其他浏览器打开
        window.platform_launch = platformLaunchH5;
        window.platform_gotoLogin = platformGotoLoginH5;
        initPheadForH5();
    }
};

var mount = function mount(xm) {
    xm.bridgePolyfill = bridgePolyfill;
};

var init = function init(xm) {
    mount(xm);
};

exports.default = {
    init: init,
    bridgePolyfill: bridgePolyfill
};