'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
//控制避免连续点击触发事件
var period = false;
var eventFun = {};

var _delegate = function _delegate(name, selector, func) {
    var key = name + selector.replace(/\s*/g, "") + (func.name || func.toString().length);
    eventFun[key] = function (e) {
        if (name === 'click') {
            if (!period) {
                period = true;
                setTimeout(function () {
                    period = false;
                }, 300);
                func.call(this, e);
            }
        } else {
            func.call(this, e);
        }
    };
    $('body').on(name, selector, eventFun[key]);
};

var _undelegate = function _undelegate(name, selector, func) {
    var key = name + selector.replace(/\s*/g, "") + (func.name || func.toString().length);
    $('body').off(name, selector, eventFun[key]);
    delete eventFun[key];
};

var _scanEventsMap = function _scanEventsMap(maps, isOn) {
    var delegateEventSplitter = /^(\S+)\s*(.*)$/;
    var bind = isOn ? _delegate : _undelegate;
    for (var keys in maps) {
        if (maps.hasOwnProperty(keys)) {
            var matchs = keys.match(delegateEventSplitter);
            bind(matchs[1], matchs[2], maps[keys]);
        }
    }
};

var initializeOrdinaryEvents = function initializeOrdinaryEvents(maps) {
    _scanEventsMap(maps, true);
};

var uninitializeOrdinaryEvents = function uninitializeOrdinaryEvents(maps) {
    _scanEventsMap(maps);
};

/**
 * 绑定事件
 * @param {*object} eventsMap 事件配置对象，属性key值表示事件类型和触发元素，以空格分隔
 */
var bindEvent = function bindEvent(eventsMap) {
    initializeOrdinaryEvents(eventsMap);
};

var unBindEvent = function unBindEvent(eventsMap) {
    uninitializeOrdinaryEvents(eventsMap);
};

var mount = function mount(xm) {
    xm.prototype.bindEvent = bindEvent;
    xm.prototype.unBindEvent = unBindEvent;
};

exports.default = {
    mount: mount,
    bindEvent: bindEvent,
    unBindEvent: unBindEvent
};