'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

require('./styles/toast.scss');

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 弹出toast，使用方法
 * 1 添加DOM
 * <div class="xm-toast">
        <div></div>
    </div>
 * 
 * 2 js调用，xm.toast('msg')
 * 
 * @param {string} text toast文案
 * @param {string} selector 选择器
 */
var toast = function toast(text, selector) {
    var toastTimeout = null,
        toastContainer = $('.xm-toast');

    if (toastContainer.length === 0) {
        return;
    }

    $('.xm-toast div').text(text);

    if (toastContainer.css('display') === 'none') {
        toastContainer.show();
        toastTimeout = setTimeout(function () {
            toastContainer.hide();
        }, 3000);
    } else {
        toastContainer.hide();
        window.clearTimeout(toastTimeout);
        toast(text, selector);
    }
    if (!_utils2.default.isNull(selector)) {
        $(selector).focus();
    }
};

var mount = function mount(xm) {
    xm.prototype.toast = toast;
};

exports.default = {
    mount: mount,
    toast: toast
};